/* This file is used to generate the Qt configuration info for the Core library.
 * The 'qt_generate_qconfig_cpp' cmake routine
 * contains variables that replace '@' entries in this file. It's important to
 * align these values with the following:
 *
 * - QLibraryInfo::LibraryPath enum in qtbase/src/corelib/global/qlibraryinfo.h
 * - qtConfEntries in qtbase/src/corelib/global/qlibraryinfo.cpp
 */
#include "private/qoffsetstringarray_p.h"

/* Installation Info */
static const char qt_configure_prefix_path_str  [12+256] = "qt_prfxpath=/usr";

static constexpr auto qt_configure_strs = QT_PREPEND_NAMESPACE(qOffsetStringArray)(
    R"qconfig(share/doc/qt6)qconfig",
    R"qconfig(include/qt6)qconfig",
    R"qconfig(lib64)qconfig",
    R"qconfig(lib64/qt6/libexec)qconfig",
    R"qconfig(lib64/qt6/bin)qconfig",
    R"qconfig(lib64/qt6/plugins)qconfig",
    R"qconfig(lib64/qt6/qml)qconfig",
    R"qconfig(lib64/qt6)qconfig",
    R"qconfig(share/qt6)qconfig",
    R"qconfig(share/qt6/translations)qconfig",
    R"qconfig(lib64/qt6/examples)qconfig",
    R"qconfig(tests)qconfig"
);

#define QT_CONFIGURE_SETTINGS_PATH "/etc/xdg"
#define QT_CONFIGURE_LIBLOCATION_TO_PREFIX_PATH "../"_L1
#define QT_CONFIGURE_PREFIX_PATH qt_configure_prefix_path_str + 12
